﻿namespace database
{
    public abstract class Abstractions
    {

        // CDUD операции для каждой сущности

        // Car
        public abstract void AddCar(Car car);
        public abstract List<Car> GetCars();
        public abstract Car GetCarById(int id);
        public abstract void UpdateCar(Car car);
        public abstract void DeleteCar(int id);

        // Client
        public abstract void AddClient(Client client);
        public abstract Client GetClientById(int id);
        public abstract List<Client> GetClients();
        public abstract void UpdateClient(Client client);
        public abstract void DeleteClient(int id);

        // Rental
        public abstract void AddRental(Rental rental);
        public abstract Rental GetRentalById(int id);
        public abstract List<Rental> GetRentals();
        public abstract void UpdateRental(Rental rental);
        public abstract void DeleteRental(int id);

        // CarModel
        public abstract void AddCarModel(CarModel carModel);
        public abstract CarModel GetCarModelById(int id);
        public abstract List<CarModel> GetCarModels();
        public abstract void UpdateCarModel(CarModel carModel);
        public abstract void DeleteCarModel(int id);

        // Branch
        public abstract void AddBranch(Branch branch);
        public abstract Branch GetBranchById(int id);
        public abstract List<Branch> GetBranches();
        public abstract void UpdateBranch(Branch branch);
        public abstract void DeleteBranch(int id);

        // Status
        public abstract void AddStatus(Status status);
        public abstract List<Status> GetStatuses();
        public abstract Status GetStatusById(int id);
        public abstract void UpdateStatus(Status status);
        public abstract void DeleteStatus(int id);

        // BodyType
        public abstract void AddBodyType(BodyType bodyType);
        public abstract List<BodyType> GetBodyTypes();
        public abstract BodyType GetBodyTypeById(int id);
        public abstract void UpdateBodyType(BodyType bodyType);
        public abstract void DeleteBodyType(int id);
    }
}
